<?php class controller_plugin_random_text extends plugin {
	protected $brackets = array('{', '}');
	protected $found_strings = array();
	protected $text_template;
	protected $ready_text;
	protected $random_text_id;
	public function random_text($source_text){
		preg_match_all('/\{[^\{]*(\|)+[^\}]*}/', $source_text, $this->found_strings);
		for($i = 0; $i < count($this->found_strings[0]); $i++){
			$this->found_strings[0][$i] = str_replace($this->brackets, '', $this->found_strings[0][$i]);
			$this->found_strings[0][$i] = explode('|', $this->found_strings[0][$i]);
		}
		$this->found_strings = $this->found_strings[0];
		for($i = 0; $i < count($this->found_strings); $i++){
			$this->text_template = preg_replace('/\{[^\{]*(\|)+[^\}]*}/', '?*?', $source_text);
			$this->text_template = explode('?', $this->text_template);
			if($this->text_template[0] == ''){
				unset($this->text_template[0]);
			}
		}
		$i = 0;
		foreach($this->text_template as $key=>&$value){
			if($value == '*'){
				$value = str_replace('*',  $this->found_strings[$i][rand(0, count($this->found_strings[$i])-1)], $value);
				$i++;
			}
		}
		$this->ready_text = implode(' ', $this->text_template);
		return $this->ready_text;
	}

	function action_index($plugin) {
		// core::print_r($plugin);
		// core::print_r($this->run_params);
		// core::print_r($plugin['id']);
		// core::print_r($this->run_params);
		$this->random_text_id = $this->run_params;
        if (!empty($this->random_text_id)) {
			$this->data['rand_text'] = $this->random_text($plugin['params']);
			if($this->random_text_id == $plugin['id']){
			$this->page['html'] = $this->load_view();}
				else{
					$this->page['html'] = '';
				}
			return $this->page;
        } else {
            trigger_error('You must give one parameter: text', E_USER_WARNING);
        }

	}
	public function action_activate() {
		// core::print_r($this);
		if (isset($_POST['activate'])) {
			$this->page['params'] = $_POST['rand_text'];
		}
		$this->page['html'] = $this->load_view('settings');
		return $this->page;
	}

	function action_settings($plugin){
		// core::print_r($this);
		$this->data['text'] = $plugin['params'];
		if (isset($_POST['edit_settings'])){
			$this->dbh->exec("UPDATE activated_modules SET params='" . $_POST['rand_text'] . "' WHERE module_dir='random_text' AND id='" . $this->url['actions'][1] . "'");
		}
		$this->page['html'] = $this->load_view('settings');
		return $this->page;		
	}



} 